
 if ("undefined" == typeof(ScanLife)) {  
  var ScanLife = {};  
}  

ScanLife.BrowserOverlay  = {

	srctype:null,
	codeURL:null,
	codeTitle:null,


	separateElements:function( wndw,  docelem, docbody) {
		var arrang =  wndw ?  wndw : 0;
		if ( docelem && (!arrang || (arrang >  docelem))) {
			arrang =  docelem;
		}
		return docbody && (!arrang || (arrang > docbody)) ? docbody : arrang;
	}
,
	 keepOnTop:function() {
		var winYOffset = (window.content.pageYOffset) ? window.content.pageYOffset : 0;
		var docElem = (window.content.document.documentElement) ? window.content.document.documentElement.scrollTop : 0;
		var docBody = (window.content.document.body) ? window.content.document.body.scrollTop : 0;
	  return this.separateElements(winYOffset, docElem, docBody);
	}
,
	displayWindow:function(URLreqParams){
		var SCANLIFE_URL = "http://app.scanlife.com/gui/browseraddon.do";
		if (window.content.document.getElementById('scanlife_window')){
			window.content.document.getElementById('scanlife_window').parentNode.removeChild(window.content.document.getElementById('scanlife_window'));
		}
		  var divWindow;
		  divWindow = window.content.document.createElement("div");
		  divWindow.id = "scanlife_window";
		  divWindow.style.border = "0";
		  divWindow.style.padding = "0";
		  divWindow.style.position = "absolute";
		  divWindow.style.right = "0px";
		  divWindow.style.zIndex = 100000000;
		  divWindow.style.margin = "10px";
		  divWindow.style.top = this.keepOnTop(window.content) + "px";
		  
		  var divClose = window.content.document.createElement("div");
		  divClose.id = "closewindow";
		  divClose.style.float="right";
		  divClose.style.fontWeight="bold";
		  divClose.style.height="30px";
		  divClose.style.paddingTop = "7px";
		  divClose.style.textAlign="right";
		  divClose.style.verticalAlign="middle";
		  divClose.innerHTML = '<a href="javascript:;" onClick="document.getElementById(\'scanlife_window\').parentNode.removeChild(document.getElementById(\'scanlife_window\'));">Close</a>';
		  
				
		  var divContent;
		  divContent = window.content.document.createElement("div");
		  divContent.id = "scanlife_content";
		  divContent.style.border = "0";
		  divContent.style.padding = "0";
		  divContent.style.position = "absolute";
		  divContent.style.width = "0px";
		  divContent.style.height = "0px";
		  divContent.style.zIndex = 0;
		  divContent.style.margin = "0px";
		  divContent.style.top = "0px";
		  divWindow.appendChild(divContent);
		
		  var divView;
		  divView = window.content.document.createElement("div");
		  divView.id = "scanlife_view";
		  divView.style.margin = "0";
		  divView.style.padding = "0";
		  divView.style.backgroundColor = "white";
		  divView.style.zIndex = 2;
		  divView.style.width = "550px";
		  divView.style.height = "450px";
		  divView.style.border = "solid rgb(180,180,180)";
		  divView.style.borderWidth = "6px";
		  divView.style.overflow = "hidden";
		  divView.style.textOverflow = "clip";
		  divView.style.position = "fixed";
		  divView.style.top = "6px";
		  divView.style.right = "6px";
		  divView.innerHTML = '<iframe id="scanlife_iframe" '
			  + ' onLoad="p = document.getElementById(\'div_content\'); if (p && p.style) {c = p.style.zIndex; if (c==7) {p.parentNode.parentNode.removeChild(p.parentNode);} p.style.zIndex = ++c;}" ' 
			  + 'name="scanlife_iframe" src="'
			  + SCANLIFE_URL+'?'+URLreqParams
			  + '" scrolling="no" frameborder="0" style="width:100%; height:100%; '
			  + 'border:1px; padding:0px; margin:0px;"></iframe>';
		divView.insertBefore(divClose,divView.firstChild);
		  divWindow.appendChild(divView);
		  window.content.document.body.appendChild(divWindow);

	}
,

	isURL:function(txt){
		var regexp = /((http(s)?|ftp|telnet|rtsp|news):\/\/|mailto:|cmshop:|mshop:)(w(\d)?\.)?(\w+\.(\w{2}|\w{3}))(:\d+)?(\/([\w\/_\.]+(\?\S+)?)?)?/
		return(regexp.test(txt));
	}
	,
	setParams:function() {
				if (this.srctype.target){  		
					if (this.srctype.onImage && !this.srctype.onLink) {
						this.codeURL = encodeURIComponent(this.srctype.target.src);
						var imgAlt;
						if (this.isURL(this.srctype.target.alt)) {
							imgAlt = '';
						} else {
							imgAlt = this.srctype.target.alt;
						}
						this.codeTitle = encodeURIComponent(imgAlt);
						//this.codeTitle = (this.srctype.target.alt)?encodeURIComponent(this.srctype.target.alt):encodeURIComponent('');
					}
					if (!this.srctype.onImage && this.srctype.onLink && this.isURL(this.srctype.linkURL.toString())){
							this.codeURL = encodeURIComponent(this.srctype.linkURL.toString());
							if (this.srctype.target.textContent && this.srctype.target.textContent != null)
								this.codeTitle = encodeURIComponent(this.srctype.target.textContent);
							else 
								this.codeTitle = encodeURIComponent('');
					}
					if (this.srctype.onImage && this.srctype.onLink && this.isURL(this.srctype.linkURL.toString())){
						this.codeURL = encodeURIComponent(this.srctype.linkURL.toString());
						this.codeTitle=encodeURIComponent('');
					}
					if (this.srctype.onTextInput){
						if(this.srctype.target.type=="text" && (this.isURL(this.srctype.target.value))){
							this.codeURL = encodeURIComponent(this.srctype.target.value);
							this.codeTitle = encodeURIComponent(''); 					
						}
					}
					if (this.srctype.isTextSelected){
						var seltxt = window.content.getSelection().toString();			
						if (this.isURL(seltxt)){
							this.codeURL = encodeURIComponent(seltxt);
							this.codeTitle = encodeURIComponent('');
						}
					}
				} else {
					this.codeURL = encodeURIComponent(this.srctype.URL);
					var pgTitle;
					if(this.isURL(this.srctype.title)) {
						pgTitle = '';
					}
					else {
						pgTitle = this.srctype.title;
					}
					this.codeTitle = encodeURIComponent(pgTitle);
				}

	}
,

	sendToScanLife:function() {
		var reqParams='url='+this.codeURL+'&popupMessege='+this.codeTitle+'&status=create'+'&codeName='+this.codeTitle;	
		this.displayWindow(reqParams);	
	}
,    
	isValidPage:function(apage){
		var pagevalid = false;
		if(apage.URL && apage.title) {
			pagevalid = (apage.URL!==null && apage.URL!=="undefined" && this.isURL(apage.URL.toString()));
		}			
		return pagevalid;
	},
	getPageInfo:function(page){
		if (this.isValidPage(page)){
			this.srctype = page;
			this.setParams();
			this.sendToScanLife();
			
		}
	}
,
	isValidSelection:function(contextMenu){
		var menuselect = false;		
    		if (contextMenu.target) {
    			menuselect = (contextMenu.onImage || this.isURL(content.window.getSelection().toString()) || (contextMenu.onLink && (this.isURL(contextMenu.linkURL.toString()))) || 
    				(contextMenu.onTextInput && (contextMenu.target.type=="text" && this.isURL(contextMenu.target.value))));
				}
    		return menuselect;
    	},
    	getLinkInfo:function(target){
    		if (this.isValidSelection(target)){
    			this.srctype = target;
    			this.setParams();
    			this.sendToScanLife();
    			}
    	},
	initMenu:function() {
	  var contextMenu = document.getElementById("contentAreaContextMenu");
	  if (contextMenu) {
	    contextMenu.addEventListener("popupshowing", this.showHideMenuItem, false);
		}
	}	
	,
	showHideMenuItem:function(event){
		var menuItem = document.getElementById("scanlife-menu");
		var menuSep = document.getElementById("scanlife-menu-sep");
		menuSep.hidden = menuItem.hidden = !(gContextMenu.onLink || gContextMenu.isTextSelected || gContextMenu.onImage || gContextMenu.onTextInput);
		
	}
};

